##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate music conversion from      ##
## original files (like Arkos Tracker .aks) into data arrays.             ##
############################################################################

##
## NEW MACROS
##

# Default values
#
#$(eval $(call AKS2DATA, SET_OUTPUTS  , h s  )) { bin, h, hs, s }
#$(eval $(call AKS2DATA, SET_SFXONLY  , no   )) { yes, no       }
#$(eval $(call AKS2DATA, SET_EXTRAPAR ,      )) 
# Conversion

##SOLO FALTA PONER EL NOMBRE DEL FICHERO Y DESCOMENTAR 
$(eval $(call AKS2DATA, SET_FOLDER   , src/assets/songs ))
$(eval $(call AKS2DATA, CONVERT      , assets/menu.aks , song_menu , 0x0240))

$(eval $(call AKS2DATA, CONVERT      , assets/C1.aks ,song_nivel1 , 0x030B))
$(eval $(call AKS2DATA, CONVERT      , assets/C2.aks , song_nivel2 , 0x03D6))
$(eval $(call AKS2DATA, CONVERT      , assets/C3.aks , song_nivel3 , 0x04E0))
$(eval $(call AKS2DATA, CONVERT      , assets/C4.aks , song_nivel4 , 0x05EA))
$(eval $(call AKS2DATA, CONVERT      , assets/C5.aks , song_nivel5 , 0x06B5))
$(eval $(call AKS2DATA, CONVERT      , assets/C6.aks , song_nivel6 , 0x0780))
$(eval $(call AKS2DATA, CONVERT      , assets/C7.aks , song_nivel7 , 0x084B))
$(eval $(call AKS2DATA, CONVERT      , assets/C8.aks , song_nivel8 , 0x0916))
$(eval $(call AKS2DATA, CONVERT      , assets/C9.aks , song_nivel9 , 0x09E1))
$(eval $(call AKS2DATA, CONVERT      , assets/C10.aks , song_nivel10 , 0x0AEB))
$(eval $(call AKS2DATA, CONVERT      , assets/C11.aks , song_nivel11 , 0x0BB6))
$(eval $(call AKS2DATA, CONVERT      , assets/C12.aks , song_nivel12 , 0x0C81))


##
## OLD MACROS (For compatibility)
##

## AUTOMATED MUSIC CONVERSION EXAMPLE (Uncomment EVAL line to use)

## Convert music/song.aks to src/music/song.s and src/music/song.h
##		This file contains a music created with Arkos Tracker. This macro 
## will convert the music into a data array called g_mysong that will be
## placed at the 0x42A0 memory address in an absolue way.
##

#$(eval $(call AKS2C,music/song.aks,g_mysong,src/music/,0x42A0))

############################################################################
##              DETAILED INSTRUCTIONS AND PARAMETERS                      ##
##------------------------------------------------------------------------##
##                                                                        ##
## Macro used for conversion is AKS2C, which has up to 5 parameters:      ##
##  (1): AKS file to be converted to data array                           ##
##  (2): C identifier for the generated data array (will have underscore  ##
##       in front in ASM)                                                 ##
##  (3): Output folder for .s and .h files generated (Default same folder)##
##  (4): Memory address where music data will be loaded                   ##
##  (5): Aditional options (you can use this to pass aditional modifiers  ##
##       to cpct_aks2c)                                                   ##
##                                                                        ##
## Macro is used in this way (one line for each image to be converted):   ##
##  $(eval $(call AKS2C,(1),(2),(3),(4),(5))                              ##
##                                                                        ##
## Important:                                                             ##
##  * Do NOT separate macro parameters with spaces, blanks or other chars.##
##    ANY character you put into a macro parameter will be passed to the  ##
##    macro. Therefore ...,src/music,... will represent "src/music"       ##
##    folder, whereas ...,  src/music,... means "  src/sprites" folder.   ##
##  * You can omit parameters by leaving them empty.                      ##
##  * Parameter  (5) (Aditional options) is  optional and  generally not  ##
##    required.                                                           ##
############################################################################
