.module Entity_manager



.include "cpctelera.h.s"
.include "man/entity.h.s"

_num_entities:: .db 0
_last_elem_ptr:: .dw _entity_array
_entity_array:: .ds max_entities*entity_size 
.db 0

_contador_vidas:: .db 00 , 00 , 00 ,00 

_muerta:   .db  0x00 , 0x00, 0x00 , 0x00 , 0x00,  0x00, 0x00
           .db  0x00, 0x00 
           .db  0x00, 0x00 , 0x000 , 0x00 , 0x00 
           .db  0x00, 0x00 
           .db  0x00 ,0x00  , 0x00


man_entity_getEntityArray_IX::
    ld      ix, #_entity_array
    ret

man_entity_getNumEntities_A::
    ld      a, (_num_entities)
    ret



;;INPUT  HL -> entidad 
;;RETURN IX -> puntero a la entidad
man_entity_create::


    call    man_entity_free_space 
    or      a
    jr      z, fin  ;; si da 0 acabo porque no hay espacio , sino sigo 

    ld      ix , (_last_elem_ptr)
    ld      de, (_last_elem_ptr)
    ld      bc, #entity_size
    ldir    

    ld      a, (_num_entities)
    inc     a
    ld      (_num_entities), a
    
    ld      hl, (_last_elem_ptr)
    ld      bc, #entity_size
    add     hl, bc 
    ld      (_last_elem_ptr), hl

fin:   
    ret



;;INPUT HL el puntero de la función  
;;      D el signature 
man_entity_forall::
    call    man_entity_getEntityArray_IX  ;; array de entidades  -> IX 
    
_desloop2:

    ld      a, 0(ix) ;; cargo tipo de entidad  0000 0011
    or      a ;; resto los tipos               0000 0011 
    ret     z ;;                              0000 0011

    push    de 
    push    hl
    call    #man_entity_forall_matching
    pop     hl 
    pop     de 

    ld      bc,#entity_size ;; carga la cantidad de atributos que tiene entity  en bc 
    add     ix, bc  
    jr      _desloop2


;;INPUT HL el puntero de la función  
;; en D el signature 
man_entity_forall_matching::
    ld      b,d  ; 0000 0001
    ld      (to_call), hl
   
    
    ld      a, 0(ix) ;0000 0001
    and     b       ;0000 0001 = 0000 0001
    sbc     a,b     ;0000 0001 - 0000 0001 =0000 0000
    ret     nz            
    
    to_call=.+1
    call    to_call
    ret


;; INPUT 
;; IX posición de puntero
man_entity_set4destroy::
    ld      0(ix),   #_e_type_dead ;;cargo en a el tipo_invalido
    ret


;;INPUT IX PUNTERO A DESTRUIR
man_entity_destroy:: 
        
    call  man_entity_getNumEntities_A ;; cuantas entidades me quedan a = 1
    
    ld      hl, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     hl,bc
    ld      (_last_elem_ptr),hl
    
    dec     a
    ld      (_num_entities),a
    
    push    ix
    pop     de
    sbc     hl,de
    jr      z ,actualizar
    
    ld      hl,(_last_elem_ptr)
    ld      bc,#entity_size
    ldir 

actualizar:
    ld      hl, (_last_elem_ptr)
    ld      (hl) ,#0
    ret



man_entity_update:: 
    call    man_entity_getEntityArray_IX  ;; array de entidades  -> IX 
    call    man_entity_getNumEntities_A   ;; numero de entidades que hay en el array vivas  -> A 
    jr      _desloop
destruir:
    call    man_entity_destroy

_desloop:
    ld      a, 0(ix) ;; cargo tipo de entidad  
    or      a ;; si da 0, No hay más entidades 
    ret     z

    call    man_entity_dead 
    jr      z, _next ;; si es NO cero elimino y si no salto al siguiente 
    jr      destruir

_next:

    ld      bc,#entity_size ;; carga la cantidad de atributos que tiene entity  en bc 
    add     ix, bc  ;; 
    jr       _desloop



;; RETURN en A el valor de free_space
man_entity_free_space::
    ld      a, (_num_entities)
    ld      b,a
    ld      a, #max_entities ;; cargamos en a el max_entities 
    sbc     a, b ;; max_entities - _num_entities 
    ret 


eliminar_entidades::
    call    man_entity_getEntityArray_IX   

    ld      a , #max_entities
_eliminar_loop:
    or      a ;; si da 0, No hay más entidades 
    jr      z, salto_eliminar

    ld      hl, #_muerta
    push    ix 
    pop     de
    ld      bc, #entity_size
    ldir    

    dec     a 
    ld      bc,#entity_size ;; carga la cantidad de atributos que tiene entity  en bc 
    add     ix, bc  ;; 
    jr       _eliminar_loop

    

salto_eliminar:
    ld      a, #0
    ld      (_num_entities), a
    

    call    man_entity_getEntityArray_IX

    push    ix
    pop     hl

    ld      (_last_elem_ptr), hl
    
    ret



man_entity_dead::

    ld 		a, 0(ix)
	ld 		b, #_e_type_dead
	and 	a , b 

    ret 