


.module Game_manager



.include "cpctelera.h.s"
;.include "man/entity.h.s"
;.include "man/menu.h.s"
;.include "man/game.h.s"
;.include "sys/render.h.s"
;;.include "cpct_globals.h.s"
;.include "sys/physics.h.s"
;.include "sys/collision.h.s"
;.include "sys/ai.h.s"



_numero_muertes:: .db 48 , 48 , 48 , 48 , 00
_final_muertes: .asciz "HAS MUERTO" 
_musica:: .db 0




man_game_loop::

    loop:
        call    sys_ai_update 
        call    sys_physics_update
        call    sys_physics_update_bala
        call    sys_collision_update

         esperar:   
            ld   a , (cont_i)
            cp #6
            jr nz, esperar
            call    sys_render_update 
            call    sys_render_death_update
         

            call     man_entity_update 

            
            ld    hl, #Key_M 
            call  cpct_isKeyPressed_asm
            jr z, continuar

            ld   a,  (_musica)  
            cp   #0 
            jr   nz , poner_play
            
            call cpct_akp_stop_asm
            ld    a, #1 
            ld   (_musica), a ;; 1 = mute

            jp continuar
      poner_play:
         ld    a, #0
         ld   (_musica), a ;; 1 = mute
         

      continuar:
         ;;PAUSA
         ld   hl, #Key_Esc
         call cpct_isKeyPressed_asm

         jr z, loop

         ld hl, #_screenpause_z_end
         ld de, #0xFFFF
         call cpct_zx7b_decrunch_s_asm


      _final_loop:
         ld   hl, #Key_Esc
         call cpct_isKeyPressed_asm

         jr z, continuamos

         jp volvemos

      continuamos:

         ;call cpct_scanKeyboard_f_asm
         ld   hl, #Key_R
         call cpct_isKeyPressed_asm
         jr z, _final_loop

         call finalizamos
         call _main

      volvemos:

         ;;CAMBIAR RENDER TILE MAP0
         ld de, (_tile_map_colision)
         call sys_render_tilemap_0

         ;;CAMBIAR RENDER TILE MAP1
         ld de, (_tile_map_colision)
         call sys_render_tilemap_1


         ;;CAMBIAR RENDER TILE MAP2
         ld de, (_tile_map_colision)
         call sys_render_tilemap_2


         ;;CAMBIAR RENDER TILE MAP3
         ld de, (_tile_map_colision)
         call sys_render_tilemap_3

         call sys_render_pause_update 

         jp loop

         ret




eliminar_todo:: 

    call  man_entity_getEntityArray_IX  ;; array de entidades  -> IX 
      
    _desloop2:

        ld a, 0(ix) ;; cargo tipo de entidad  0000 0011
        or a ;; resto los tipos               0000 0011 
        jr z , actualizar_entidades;;                              0000 0011

        ld a, #_e_type_dead
        ld 0(ix), a 

        ld      bc,#entity_size ;; carga la cantidad de atributos que tiene entity  en bc 
        add     ix, bc  
        jr       _desloop2

    actualizar_entidades: 
        call man_entity_update

        ret 



finalizamos::


   ld a, #0
   ld (_IndiceNiveles),a 
   ld (_IndiceMusica), a 
   ld hl , #_contador_vidas

   ld (hl), a 
   inc hl 
   ld (hl), a
   inc hl 
   ld (hl), a 
   inc hl 
   ld (hl), a 

   ret  

ganar::

   call eliminar_todo

   ld hl, #_screenganar_z_end
   ld de, #0xFFFF
   call cpct_zx7b_decrunch_s_asm
   

   ganar_loop:

      ld   hl, #Key_Return
      call cpct_isKeyPressed_asm

      jr z,    ganar_loop
      
      call     finalizamos
      call     man_menu_creditos
      call     wait_esc 


      ret

cargar_numero_muertes::
   ld  hl , #_numero_muertes

   ld a, #48
   ld (hl), a 
   inc hl 
   ld (hl), a
   inc hl 
   ld (hl), a 
   inc hl 
   ld (hl), a 
   
   ld  hl , #_numero_muertes
   ld  bc , #_contador_vidas

   ld a , (hl)
   ld e , a 
   ld a , (bc) 
   ld d , a 
   ld a , e 
   add d 

   ld  (hl) , a ;; millar  

   inc hl 
   inc bc 

   ld a , (hl)
   ld e , a 
   ld a , (bc) 
   ld d , a 
   ld a , e 
   add d 

   ld  (hl) , a ;; centenas 

   inc hl 
   inc bc 
   
   ld a , (hl)
   ld e , a 
   ld a , (bc) 
   ld d , a 
   ld a , e 
   add d 

   ld  (hl) , a ;; decenas

   inc hl 
   inc bc 
   
   ld a , (hl)
   ld e , a 
   ld a , (bc) 
   ld d , a 
   ld a , e 
   add d 

   ld  (hl) , a ;; unidades 

   ret



game_over::

   call eliminar_todo

   ld hl, #_screenover_z_end
   ld de, #0xFFFF
   call cpct_zx7b_decrunch_s_asm

   game_over2:
      ld   hl, #Key_R
      call cpct_isKeyPressed_asm

      jr z, game_over2

      call _main

      ret  


