.module Interruption_manager



.include "cpctelera.h.s"
.include "man/interruption.h.s"
;.include "sys/music.h.s"



.macro   setNextManIR dirreccion 
   ld    hl, #dirreccion   
   ld    (0x39) , hl 
.endm

.macro setNumIR number 
   ld    a, #number
   ld    (num_i), a 
.endm 

num_i:: .db 00
cont_i:: .db 00

;MUERTE PERSONAJE
cont_esperar:: .db 00
contar:: .db 00 

man_ir1::
   cpctm_push af , bc , de , hl 
   push  ix
   push  iy 

   setNumIR 1
   setNextManIR man_ir2

   ;cpctm_setBorder_asm HW_BLACK 
   ld   a , (cont_i)
   inc  a 
   ld   (cont_i), a

   ld    a , (contar)
   cp    #1 
   jr    nz , saltar

   ld    a, (cont_esperar)
   inc   a 
   ld    (cont_esperar), a 

saltar:
   pop  iy 
   pop  ix
   cpctm_pop  hl , de , bc , af    
   ei 
   reti

man_ir2::
   cpctm_push af , bc , de , hl 
   push  ix
   push  iy 

   setNumIR 2
   setNextManIR man_ir3
   ;cpctm_setBorder_asm HW_GREEN
   ld   a , (cont_i)
   inc  a 
   ld   (cont_i), a

   ld    a , (contar)
   cp    #1 
   jr    nz , saltar2

   ld    a, (cont_esperar)
   inc   a 
   ld    (cont_esperar), a 

saltar2:
   pop iy
   pop ix 
   cpctm_pop  hl , de , bc , af    
   ei 
   reti

man_ir3::
   cpctm_push af , bc , de , hl 
   push ix
   push iy 

   setNumIR 3
   setNextManIR man_ir4
   ;cpctm_setBorder_asm HW_YELLOW
   ld   a , (cont_i)
   inc  a 
   ld   (cont_i), a

   ld    a , (contar)
   cp    #1 
   jr    nz , saltar3

   ld    a, (cont_esperar)
   inc   a 
   ld    (cont_esperar), a 

saltar3:
   pop iy 
   pop ix 
   cpctm_pop  hl , de , bc , af    
   ei 
   reti

man_ir4::
   cpctm_push af , bc , de , hl 
   exx 
   ex af,af'
   cpctm_push af , bc , de , hl 
   push ix 
   push iy 

   setNumIR 4
   setNextManIR man_ir5

   ld   a , (cont_i)
   inc  a 
   ld   (cont_i), a

   ld    a , (contar)
   cp    #1 
   jr    nz , saltar4

   ld    a, (cont_esperar)
   inc   a 
   ld    (cont_esperar), a 

saltar4:
   ld   a , (cont_i)
   cp #4 
   jr nz, seguir4
   ;cpctm_setBorder_asm HW_BLACK
   call cpct_scanKeyboard_if_asm
   ;cpctm_setBorder_asm HW_BRIGHT_GREEN
   
   ld   a,  (_musica)  
   cp   #0 
   jr   nz , seguir4
   call sys_music_play
   

seguir4:
   ;cpctm_setBorder_asm HW_RED
   pop iy 
   pop ix 
   cpctm_pop  hl , de , bc , af    
   exx
   ex af, af'
   cpctm_pop  hl , de , bc , af    
   ei 
   reti

man_ir5::
   cpctm_push af , bc , de , hl 
   push ix 
   push iy 

   setNumIR 5
   setNextManIR man_ir6

   ;cpctm_setBorder_asm HW_GREEN
   ld   a , (cont_i)
   inc  a 
   ld   (cont_i), a

   ld    a , (contar)
   cp    #1 
   jr    nz , saltar5

   ld    a, (cont_esperar)
   inc   a 
   ld    (cont_esperar), a 

saltar5:

   pop iy 
   pop ix 
   cpctm_pop  hl , de , bc , af    
   ei 
   reti

man_ir6::
   cpctm_push af , bc , de , hl 
   push ix 
   push iy 

   setNumIR 6
   setNextManIR man_ir1

   ;cpctm_setBorder_asm HW_WHITE

   ld   a , (cont_i)
   inc  a 
   ld   (cont_i), a

   ld    a , (contar)
   cp    #1 
   jr    nz , saltar6

   ld    a, (cont_esperar)
   inc   a 
   ld    (cont_esperar), a 

saltar6:
   ld   a , (cont_i)
   cp #12
   jr nz, seguir12

   ld a , #0 
   ld (cont_i) , a 

seguir12: 
   pop iy 
   pop ix 
   cpctm_pop  hl , de , bc , af    
   ei 
   reti

man_interruption_init::
   ;; MODO 1 DE INTERRRUPCIONES 
   im    1

   ;; CON ESTO ESPERAMOS A EL WAITVSYNC
   call cpct_waitVSYNC_asm
   halt  
   halt
   call cpct_waitVSYNC_asm
   
   ;;DESHABILITAR INTERRUPCIONES 
   di 

   ;; CAMBIARMOS 38 Y 39 DE MEMORIA 
   ld    a, #0xC3
   ld    (0x38), a 
   ;; POENEMOS EL MAN_IR1 
   ld    hl, #man_ir1
   ld    (0x39), hl
   
   ;; HABILITAMOS INTERRUPCIONES 
   ei 
   ret 

