


.module Collision_system



.include "cpctelera.h.s"
.include "sys/collision.h.s"
;.include "sys/music.h.s"
;.include "man/game.h.s"
;.include "man/level.h.s"




comprobacion_primera_0_entidad::
    
    ld      a, 0(ix) ;; cargo el primer tipo  1000
    and     b                ;              0000
    sbc     a,b              ; 0000 - 0100 = 00 - 04 = FB -> 1111 1011
    
    ret 

comprobacion_primera_18_entidad::
    
    ld      a, 18(ix) ;; cargo el primer tipo  1000
    and     b                ;              0000
    sbc     a,b              ; 0000 - 0100 = 00 - 04 = FB -> 1111 1011
    
    ret     

;;Input B ->tipo
comprobacion_segunda_0_entidad::
    
    ld      a, 0(iy) ;;           0000
    and     b                   ; 0000  
    sbc     a,b              ; 0000 - 0001 = 00 - 04 = FF -> 1111 1011
    
    ret 

;;Input B ->tipo
comprobacion_segunda_18_entidad::
    
    ld      a, 18(iy) ;;           0000
    and     b                   ; 0000  
    sbc     a,b              ; 0000 - 0001 = 00 - 04 = FF -> 1111 1011
    
    ret 

sys_collision_check::
    
    ld      a, 1(ix)
    add     3(ix)
    sub     #3
    sub     1(iy)
    ret     c 

    ld      a, 1(iy)
    add     3(iy)
    sub     #3
    sub     1(ix)
    ret     c 

    ld      a, 2(ix)
    add     4(ix)
    sub     2(iy)
    ret     c 

    ld      a, 2(iy)
    add     4(iy)
    sub     2(ix)
    ret     c 

    ;; IF DE PLAYER 
    ld      b , #_e_type_input 
    call    comprobacion_primera_0_entidad
    jr      nz, no_player

    ;; IF DE ENEMY
    ld      b, #_e_type_ia
    call    comprobacion_segunda_0_entidad
    jr      z , comprobacion_no_obs 
    ;;IF BULLET ENEMY
    ld      b , #_e_type_bullet_enemy
    call    comprobacion_segunda_18_entidad
    jr      z, matar_player

    ;; IF misil 
    ld      b , #_e_type_misil
    call    comprobacion_segunda_18_entidad
    jr      nz, no_enemy

matar_player:
    ld      a , #1 
    ld      (contar) ,a
esperar:
    cpctm_setBorder_asm HW_RED
    ld      a , (cont_esperar)
    cp      #50
    jr      nz, esperar 
    

    ld      a , #0 
    ld      (contar) ,a
    ld      (cont_esperar), a 
    call    man_entity_set4destroy
    cpctm_setBorder_asm HW_BLACK
    call    mismo_nivel

comprobacion_no_obs: 
    ;; IF DE GENERADOR FLACHAS 
    ld      b, #_e_type_obs_shoter
    call    comprobacion_segunda_18_entidad
    jr      z , no_enemy

    jp      matar_player 

no_enemy: 
    ld      b, #_e_type_final
    call    comprobacion_segunda_18_entidad
    jr      nz, no_final
    
    call    ganar

no_final:
    ld      b, #_e_type_puerta
    call    comprobacion_segunda_18_entidad
    jr      nz, no_player

    call    next_level
no_player:        
    ;; IF ENEMY - BULLET 
    ld      b, #_e_type_ia ; 0100
    call    comprobacion_primera_0_entidad
    jr      nz, no_colision

    ld      b, #_e_type_bullet ; 0100
    call    comprobacion_segunda_0_entidad
    jr      nz, no_colision

    ;;IF BULLET ENEMY
    ld      b, #_e_type_bullet_enemy ; 0100 
    call    comprobacion_segunda_18_entidad
    jr      z, no_colision

    ld      b, #_e_type_misil ; 0100 
    call    comprobacion_segunda_18_entidad
    jr      z, no_colision

    ld      a,  #_e_type_dead ;;cargo en a el tipo_invalido
    ld      0(ix), a
    ld      0(iy), a

    call    reset_disparo

no_colision:
  
    ret 


incrementar_cont_vida::
    
    ld      de , #_contador_vidas    
    inc     de
    inc     de
    inc     de ;; moviendome a las unidades
    ld      a , (de) 

    inc     a ;; sumando 1 al unidades
    cp      #0x0A
    jr      nz , incrementar

    ld      a, #0 ;; unidades a 0 
    ld      (de) , a  ;; cargando en las unidades 0 

    dec     de ;; moviendome hacia las decenas
    
    ld      a , (de);; cargo en a lo que contienen las decenas 
    inc     a ;; incrementar en uno las decenas
    cp      #0x0A 
    jr      nz , incrementar

    ld      a, #0 ;; decenas a 0 
    ld      (de) , a  ;; cargando en las decenas 0 

    dec     de ;; moviendome hacia las centenas 

    ld      a , (de);; cargo en a lo que contienen las centenas 
    inc     a ;; incrementar en uno las centenas
    cp      #0x0A 
    jr      nz , incrementar

    ld      a, #0 ;; centenas a 0 
    ld      (de) , a  ;; cargando en las centenas 0 

    dec     de ;; moviendome hacia las millares 

    ld      a , (de);; cargo en a lo que contienen las millares 
    inc     a ;; incrementar en uno las millares
    cp      #0x0A 
    jr      nz , incrementar

    ld      a, #0 ;; millares a 0 
                  ;; cargando en las millares 0 

incrementar: 
    ld     (de) , a ;; cargo en las unidades uno mas
    
    ret 


mismo_nivel::    
    ld      a, (_IndiceNiveles)
    dec     a 
    dec     a 
    dec     a 
    dec     a 
    ld      (_IndiceNiveles), a

    call    incrementar_cont_vida

    pop af 
    pop af 
    pop af 
    pop af 
    pop af 
    pop af 
    pop af 
    pop af 
    pop af 
    pop af 
    pop af 
    pop af 

    ld a , #0x80
    ld b , #0x00 
    ld hl, #0xA3A0
loop_memoria1:
    ld (hl), b
    inc hl 
    dec a   
    or a 
    jp nz, loop_memoria1

    ld    sp, #0xA400


    call    cargador_nivel

    ret 

next_level::

    ;call    pantalla_next_level

    ld hl, #_screenmenu_z_end
    ld de, #0xFFFF
    
    call cpct_zx7b_decrunch_s_asm 

    ;TODO:Hacer que le tenga que pulsar al espacio

    pop af 
    pop af 
    pop af 
    pop af 
    pop af 
    pop af 
    pop af 
    pop af 
    pop af
    pop af 
    
   ld a , #0x80
    ld b , #0x00 
    ld hl, #0xA3A0
loop_memoria:
    ld (hl), b
    inc hl 
    dec a   
    or a 
    jp nz, loop_memoria

    ld    sp, #0xA400

    call    sys_music_next_song
    call    cargador_nivel

    ret 

;;INPUT IX posicion puntero entidad 
sys_collision_update_one_entity::

    push    ix 
    pop     iy
    
    ld      bc,#entity_size ;; carga la cantidad de atributos que tiene entity  en bc 
    add     iy, bc  

_desloop2:
    ;; IF ENEMIGO PEQUEÑO 
    ld      a, 18(ix)
    ld      b, #_e_type_enemy_small
    and     a, b 
    sbc     a,b             
    jr      nz, col_normal 
    
    call    colisiones_enemigo_pequeño
    jp      seguir 
 
col_normal:

    call    colisiones

seguir:
    ld      a, 0(iy) ;; cargo tipo de entidad  0000 0011
    or      a ;; resto los tipos               0000 0011 
    ret     z ;;                             0000 0011

    call    sys_collision_check

    ld      bc,#entity_size ;; carga la cantidad de atributos que tiene entity  en bc 
    add     iy, bc  
    jr       _desloop2


colisiones_enemigo_pequeño:: 

    ld      b, #6
    ld      c, #3
    call colision_abajo_map 
    or      a
    jr nz, colision_izquierda_peq

    ld      b, #6
    ld      c, #2
    call colision_abajo_map
    or      a
    jr nz, colision_izquierda_peq

    ld      b, #6
    ld      c, #1
    call colision_abajo_map

colision_izquierda_peq:

    ld b, #4
    ld c, #4
    call colision_izquierda_map
    or a
    jr nz, colision_derecha_peq

    ld b, #3
    ld c, #4
    call colision_izquierda_map
    or a
    jr nz, colision_derecha_peq

    ld b, #0
    ld c, #4
    call colision_izquierda_map

colision_derecha_peq:

    ld b, #4
    ld c, #6
    call colision_derecha_map
    or a
    jr nz, salir_peq

    ld b, #3
    ld c, #6
    call colision_derecha_map
    or a
    jr nz, salir_peq

    ld b, #2
    ld c, #6
    call colision_derecha_map

salir_peq:
    ret


colisiones:: 


    ld b, #15
    ld c, #3
    call colision_abajo_map
    or a
    jr nz, colision_izquierda

    ld b, #15
    ld c, #4
    call colision_abajo_map 
    or a
    jr nz, colision_izquierda

    ld b, #15
    ld c, #1
    call colision_abajo_map

colision_izquierda:

    ld b, #14
    ld c, #4
    call colision_izquierda_map
    or a
    jr nz, colision_derecha

    ld b, #7
    ld c, #4
    call colision_izquierda_map
    or a
    jr nz, colision_derecha

    ld b, #0
    ld c, #4
    call colision_izquierda_map

colision_derecha:

    ld b, #14
    ld c, #9
    call colision_derecha_map
    or a
    jr nz, colision_arriba
    
    ld b, #7
    ld c, #9
    call colision_derecha_map
    or a
    jr nz, colision_arriba

    ld b, #0
    ld c, #9
    call colision_derecha_map

colision_arriba:
    
    ld b, #0
    ld c, #0
    call colision_arriba_map
    or a
    jr nz, acabo

    ld b, #0
    ld c, #3
    call colision_arriba_map
    or a
    jr nz, acabo

    ld b, #0
    ld c, #4
    call colision_arriba_map

acabo:
    ret 
 


sys_collision_update::

    ld      d, #_e_type_collision
    ld      hl, #sys_collision_update_one_entity
    call    man_entity_forall

    ld      d, #_e_type_bullet
    ld      hl, #sys_collision_update_bullet_entity
    call    man_entity_forall

    call    man_entity_dead 
    jr      z, salida
    ld      a, #0x01
salida:
    ret 


sys_collision_update_bullet_entity::

    ld      b , #_e_type_misil
    call    comprobacion_primera_18_entidad
    jr      nz, col_izquierda    

    ld      a , 12(ix)
    cp      #3
    jr      nz , no_down
    
    ld      b, #6
    ld      c, #3
    call    colision_abajo_map 
    or      a
    jr      nz, matar_bullet 
    
    ld      b, #6
    ld      c, #0
    call    colision_abajo_map
    or      a
    jr      nz, matar_bullet 

no_down: 
    ld  a , 12(ix)
    cp  #2
    jr  nz , col_izquierda
    
    ld      b, #0
    ld      c, #0
    call    colision_arriba_map
    or      a
    jr nz,  matar_bullet

    ld      b, #0
    ld      c, #3
    call    colision_arriba_map
    or      a
    jr nz,  matar_bullet

col_izquierda:
    ld      b, #0 ;Y  -> hacia abajo 
    ld      c, #4 ;X  -> hacia la izquierda 
    call    colision_izquierda_map
    or      a
    jr      nz, matar_bullet 

    ld      b, #6 ;Y 
    ld      c, #4 ;X
    call    colision_izquierda_map
    or      a
    jr      nz, matar_bullet 

col_derecha: 
    ld      b, #0
    ld      c, #6
    call    colision_derecha_map
    or      a 
    jr      nz, matar_bullet

    ld      b, #6
    ld      c, #6
    call    colision_derecha_map
    or      a 
    jr      nz, matar_bullet

    
    ld      a, 1(ix) ;; x 
    ld      b, #1
    add     b ;; newx  
    ld      c , #0x4A
    sbc     a,c ;;
    jr      z, matar_bullet 
 
    ld      a, 1(ix) ;; x 
    ld      b, #-1 
    add     b ;; newx 
    or      a ;; comprobacion de que es cero
    jr      z, matar_bullet

    ret

matar_bullet::
    call    man_entity_set4destroy

    ;;IF BULLET ENEMY
    ld      b , #_e_type_bullet_enemy
    call    comprobacion_primera_18_entidad
    jr      nz, no_bullet_enemy

    call    reset_disparo_enemy 

    ret
    
no_bullet_enemy:
    ld      b , #_e_type_misil
    call    comprobacion_primera_18_entidad
    jr      nz, no_misil

    call    reset_disparo_enemy 

    ret

no_misil:
    call    reset_disparo
    ret


reset_disparo_enemy::
    
    ld      h , 15(ix)
    ld      l , 14(ix)

    push    ix  ;; guardo ix de bullet
    
    push    hl  ;; guardo ix de enemy
    pop     ix  ;; saco ix de enemy 

    ld      13(ix), #0 ;; enemy
    
    pop     ix ;; sacar el ix de bullet
    
    ret 

reset_disparo::
    
    push    ix 
    call    man_entity_getEntityArray_IX
    ld      13(ix), #0 
    pop     ix 

    ret 


colision_mata_jugador::
    ld      a ,(hl) ;; INDICE DEL TILE DEL LADO IZQUIERDO

    cp      #2
    jr      z, matar_personaje

    cp      #3
    jr      z, matar_personaje

    cp      #4
    jr      z, matar_personaje

    cp      #5
    jr      z, matar_personaje

    cp      #7
    jr      nz, fin_matar


matar_personaje: 
    ld      a , #1 
    ld      (contar) ,a
esperar2:
    cpctm_setBorder_asm   HW_RED
    ld      a , (cont_esperar)
    cp      #50
    jr      nz, esperar2 
    
    ld      a , #0 
    ld      (contar) ,a
    ld      (cont_esperar), a 
    cpctm_setBorder_asm   HW_BLACK
    call    mismo_nivel

fin_matar:
    ret 


reposicion::
    cp      #1 
    jr      z, reposicion_salir;;COLISIONA CON TILE SUELO

    cp      #6 
    jr      z, reposicion_salir;;COLISIONA CON TILE SUELO

    cp      #8
    jr      z, reposicion_salir;;COLISIONA CON TILE SUELO

    cp      #9
    jr      z, reposicion_salir;;COLISIONA CON TILE SUELO

    cp      #10
    jr      z, reposicion_salir;;COLISIONA CON TILE SUELO

    cp      #11
    jr      z, reposicion_salir;;COLISIONA CON TILE SUELO
   
    cp      #12
    jr      z, reposicion_salir;;COLISIONA CON TILE SUELO

    cp      #13
    jr      z, reposicion_salir;;COLISIONA CON TILE SUELO

    cp      #14
    jr      z, reposicion_salir;;COLISIONA CON TILE SUELO

reposicion_salir:
    ret 


colision_arriba_map::
    
    ;;TX = x/4
    ;;TY = Y/8 
    ;;TW = tilemap-width (20)
    ;; P = tilemap + TY * TW + TX 
    
    call    colision_up_down_map
    ret     z ; NO COLISIONA
    
    call    reposicion
    jr      z, reposicion_up

    ld      b, #_e_type_input ; 0100
    call    comprobacion_primera_0_entidad
    jr      nz,  fin_up     

    call    colision_mata_jugador
    jr      nz, fin_up

reposicion_up:
;;  REPOSICION EN Y

    ld      a, 2(ix)
    ld      b, #5
    add     a, b

    ld      2(ix), a
    ld      6(ix), #1
    ld     11(ix), #-1

fin_up:
    ret 

colision_abajo_map::
    
    ;;TX = x/4
    ;;TY = Y/8 
    ;;TW = tilemap-width (20)
    ;; P = tilemap + TY * TW + TX 
    call    colision_up_down_map
    ret     z ; NO COLISIONA
    
    call    reposicion
    jr      z, reposicion_down

    ld      b, #_e_type_input ; 0100
    call    comprobacion_primera_0_entidad
    jr      nz,  fin_down      

    call    colision_mata_jugador
    jr      nz, fin_down

reposicion_down:
;;  REPOSICION EN Y
    ld      a , c 
    add     a , a ; ty *2 
    add     a , a ; ty * 4 
    add     a , a ; ty * 8 
    push    af
    
    ld      b, #_e_type_enemy_small
    call    comprobacion_primera_18_entidad     
    jr nz,  col_down_normal 
    pop     af
    add     #-6
    jp      seguir_down 

col_down_normal:
    pop     af 
    add     #-15

seguir_down:
    ld      2(ix) , a 

    ld      6(ix), #0
    ld      11(ix), #0

fin_down:
    ret 



colision_izquierda_map::

    ;;TX = x/4
    ;;TY = Y/8 
    ;;TW = tilemap-width (20)
    ;; P = tilemap + TY * TW + TX 
    
    call    colision_izq_der_map
    ret     z ; NO COLISIONA

    call    reposicion
    jr      z, reposicion_left

    ld      b, #_e_type_input ; 0100
    call    comprobacion_primera_0_entidad
    jr      nz,  fin_left  
   
    call    colision_mata_jugador
    jr      nz, fin_left

reposicion_left:


;;  REPOSICION EN X
    ld a, 1(ix)
    ld b, #-1
    sbc a, b

    ld      1(ix) , a


    ld      5(ix), #1

    ld      b, #_e_type_bullet
    call    comprobacion_primera_0_entidad
    jr      nz , fin_left

    call    matar_bullet 



fin_left:
    ret 

colision_derecha_map::

    ;;TX = x/4
    ;;TY = Y/8 
    ;;TW = tilemap-width (20)
    ;; P = tilemap + TY * TW + TX 
    call    colision_izq_der_map
    ret     z ; NO COLISIONA
    
    call    reposicion
    jr      z, reposicion_right

    ld      b, #_e_type_input ; 0100
    call    comprobacion_primera_0_entidad
    jr      nz,  fin_right
    
    call    colision_mata_jugador
    jr      nz, fin_right

reposicion_right:
    ld      b, #_e_type_bullet
    call    comprobacion_primera_0_entidad
    jr      nz , continuar

    call    matar_bullet

continuar:
;;  REPOSICION EN X
    ld      a, 1(ix)
    ld      b, #0
    sbc     a, b
    ld      1(ix) , a

    ld      5(ix), #0xFF
    

fin_right:
    ret 


colision_izq_der_map::
    
    ld      a, 2(ix)
    add     b
    srl     a 
    srl     a 
    srl     a  ;; Y/8

    ld      h , #0
    ld      l , a  
    push    hl

    ld      h, #0 
    ld      l,a 
    add     hl,hl ; 2
    add     hl,hl ;4
    ld      d,h
    ld      e,l
    add     hl,hl ;8
    add     hl,hl ;16
    add     hl,de  ;; Y * 20 

    ld      a, 1(ix)
    add     c
    srl     a 
    srl     a ;; X/4

    ld      b,#0
    ld      c,a 
    add     hl , bc 
    ld      de, (_tile_map_colision)
    add     hl, de 
    dec     hl 

    pop     bc
    ld      a ,(hl) ;; INDICE DEL TILE DEL LADO IZQUIERDO
    cp      #0  
    
    ret 


colision_up_down_map::

    ld      a, 2(ix)
    add     b
    srl     a 
    srl     a 
    srl     a  ;; Y/8

    ld      h , #0
    ld      l , a  
    push    hl

    ld      h, #0 
    ld      l,a 
    add     hl,hl ; 2
    add     hl,hl ;4
    ld      d,h
    ld      e,l
    add     hl,hl ;8
    add     hl,hl ;16
    add     hl,de  ;; Y * 20 

    ld      a, 1(ix)
    add     c
    srl     a 
    srl     a ;; X/4

    ld      b,#0
    ld      c,a 
    add     hl , bc 
    ld      de, (_tile_map_colision)
    add     hl, de 

    pop     bc
    ld      a ,(hl) ;; INDICE DEL TILE COLISION  
    cp      #0  

    ret 